package com.adaptionsoft.games.uglytrivia

import com.adaptionsoft.games.uglytrivia.actions.AddPlayer
import com.adaptionsoft.games.uglytrivia.core.GameBoard
import com.adaptionsoft.games.uglytrivia.core.Turn
import com.adaptionsoft.games.uglytrivia.infrastructure.AutogeneratedQuestions
import com.adaptionsoft.games.uglytrivia.infrastructure.InMemoryPlayerPositions
import org.amshove.kluent.`should throw`
import org.amshove.kluent.invoking
import org.junit.jupiter.api.Test

class GameShould {
    @Test
    fun `have a maximum of five players`() {
        `given a game with five players`()

        `then should fail` {
            `when another player is added`()
        }

    }

    private fun `then should fail`(function: () -> Unit) {
        invoking { function() } `should throw` Exception::class
    }

    private fun `when another player is added`() {
        addPlayerToGame()
    }

    private fun `given a game with five players`() {
        addPlayerToGame()
        addPlayerToGame()
        addPlayerToGame()
        addPlayerToGame()
        addPlayerToGame()
    }

    val gameboard = GameBoard(AutogeneratedQuestions(), InMemoryPlayerPositions())
    val turn = Turn()

    private fun addPlayerToGame() {
        AddPlayer(gameboard, turn)("foo")
    }
}